; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BEGRUESSUNG:
	ldi temp1,BYTE1(2015)
	ldi temp2,BYTE2(2015)
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
  	STS(adr_LED_BYTE_3), temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TASTATURCHECK:
	; Taste "PLUS"gedrckt ?		
	sbis (TASTE_PLUS_PIN),(TASTE_PLUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	rjmp ANZEIGE_TASTATURCHECK_ERROR
	; Taste "MINUS"gedrckt ?		
	sbis (TASTE_MINUS_PIN),(TASTE_MINUS_PIN_NR)				; springe, wenn BIT(PIN) high	
	rjmp ANZEIGE_TASTATURCHECK_ERROR
	ret
ANZEIGE_TASTATURCHECK_ERROR:
	ldi temp,(ZEICHEN_E)
	STS(adr_LED_BYTE_0), temp	
	STS(adr_LED_BYTE_1), temp
  	STS(adr_LED_BYTE_2), temp
  	STS(adr_LED_BYTE_3), temp
	rcall wait_100ms
	STS(adr_LED_BYTE_0), NULL
	STS(adr_LED_BYTE_1), NULL 
  	STS(adr_LED_BYTE_2), NULL
  	STS(adr_LED_BYTE_3), NULL 
	rcall wait_100ms
	rjmp ANZEIGE_TASTATURCHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEMPERATUR_KTY:
    LDS temp1,(adr_TEMPERATUR_KTY_L)
    LDS temp2,(adr_TEMPERATUR_KTY_H)
	clr temp3
	clr temp4

	; negativ ?
 	tst temp2
	brmi ANZEIGE_TEMPERATUR_KTY_NEG	 	

 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ori temp2, 0b10000000
	rcall NULLSTELLENUNTERDRUECKUNG
    ; TEMPERATUR
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
  	STS(adr_LED_BYTE_3), temp4
	ret
ANZEIGE_TEMPERATUR_KTY_NEG:  
	; invertieren
	com temp1 	
	com temp2 	
	; + 1
	add temp1,EINS
	adc temp2,NULL

 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	ori temp2, 0b10000000
    ; TEMPERATUR
	STS(adr_LED_BYTE_0), temp1	
	STS(adr_LED_BYTE_1), temp2
  	STS(adr_LED_BYTE_2), temp3
  	; vorzeichen
	ldi temp4,(ZEICHEN_MINUS)
	STS(adr_LED_BYTE_3), temp4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_STRICH4:
	; LEDs				
	ldi temp, (ZEICHEN_MINUS)
	STS(adr_LED_BYTE_0),temp
	STS(adr_LED_BYTE_1),temp
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_3),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_2_STELLEN_HEXADEZIMAL:

	rcall FUNKTION_HEX
	STS(adr_LED_BYTE_0), temp1
	STS(adr_LED_BYTE_1), temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_1_STELLEN_HEX_ASC_LINKS:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	STS(adr_LED_BYTE_3), temp1	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
ANZEIGE_2_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	rcall NULLSTELLENUNTERDRUECKUNG
	rcall LED_AUSGABE_ZAHL_2_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1																	
; rcall ANZEIGE_3_STELLEN_HEX_ASC ; INPUT: TEMP1                                
ANZEIGE_3_STELLEN_HEX_ASC:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	;rcall NULLSTELLENUNTERDRUECKUNG
	rcall LED_AUSGABE_ZAHL_3_STELLEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1+TEMP2															
; rcall ANZEIGE_4_STELLEN_HEX_ASC   ; INPUT: TEMP1+TEMP2                        
ANZEIGE_4_STELLEN_HEX_ASC:
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32				; INPUT: temp1...4 OUTPUT: Temp1...8			
	;rcall NULLSTELLENUNTERDRUECKUNG
	rcall LED_AUSGABE_ZAHL_4_STELLEN_KURZ
ret
;######################################################################## 
;######################################################################## 
;######################################################################## 
LED_AUSGABE_ZAHL_4_STELLEN_KURZ:
	STS(adr_LED_BYTE_3), temp4			; 4.ZEICHEN 

LED_AUSGABE_ZAHL_3_STELLEN_KURZ:
	STS(adr_LED_BYTE_2), temp3			; 3.ZEICHEN 

LED_AUSGABE_ZAHL_2_STELLEN_KURZ:
	STS(adr_LED_BYTE_1), temp2			; 2.ZEICHEN 
	
LED_AUSGABE_ZAHL_1_STELLEN_KURZ:
	STS(adr_LED_BYTE_0),temp1			; 1.ZEICHEN (1-er Stelle)	

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)

	; auf 7 SEGNMENT
	mov temp,temp1
	rcall FUNKTION_7_SEGMENT
	mov temp1,temp

	mov temp,temp2
	rcall FUNKTION_7_SEGMENT
	mov temp2,temp


	mov temp,temp3
	rcall FUNKTION_7_SEGMENT
	mov temp3,temp

	mov temp,temp4
	rcall FUNKTION_7_SEGMENT
	mov temp4,temp

	mov temp,temp5
	rcall FUNKTION_7_SEGMENT
	mov temp5,temp

	mov temp,temp6
	rcall FUNKTION_7_SEGMENT
	mov temp6,temp

	mov temp,temp7
	rcall FUNKTION_7_SEGMENT
	mov temp7,temp

	mov temp,temp8
	rcall FUNKTION_7_SEGMENT
	mov temp8,temp

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
FUNKTION_7_SEGMENT:
	cpi temp,'0'
	breq FUNKTION_7_SEGMENT_0
	cpi temp,'1'
	breq FUNKTION_7_SEGMENT_1
	cpi temp,'2'
	breq FUNKTION_7_SEGMENT_2
	cpi temp,'3'
	breq FUNKTION_7_SEGMENT_3
	cpi temp,'4'
	breq FUNKTION_7_SEGMENT_4
	cpi temp,'5'
	breq FUNKTION_7_SEGMENT_5
	cpi temp,'6'
	breq FUNKTION_7_SEGMENT_6
	cpi temp,'7'
	breq FUNKTION_7_SEGMENT_7
	cpi temp,'8'
	breq FUNKTION_7_SEGMENT_8
	cpi temp,'9'
	breq FUNKTION_7_SEGMENT_9
	; ERROR
	ldi temp, (ZEICHEN_E)
	ret
FUNKTION_7_SEGMENT_0:
	ldi temp, (ZAHL_0)
	ret
FUNKTION_7_SEGMENT_1:
	ldi temp, (ZAHL_1)
	ret
FUNKTION_7_SEGMENT_2:
	ldi temp, (ZAHL_2)
	ret
FUNKTION_7_SEGMENT_3:
	ldi temp, (ZAHL_3)
	ret
FUNKTION_7_SEGMENT_4:
	ldi temp, (ZAHL_4)
	ret
FUNKTION_7_SEGMENT_5:
	ldi temp, (ZAHL_5)
	ret
FUNKTION_7_SEGMENT_6:
	ldi temp, (ZAHL_6)
	ret
FUNKTION_7_SEGMENT_7:
	ldi temp, (ZAHL_7)
	ret
FUNKTION_7_SEGMENT_8:
	ldi temp, (ZAHL_8)
	ret
FUNKTION_7_SEGMENT_9:
	ldi temp, (ZAHL_9)
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
NULLSTELLENUNTERDRUECKUNG:

	cpi temp8,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp8,(ZEICHEN_AUS)

	cpi temp7,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp7,(ZEICHEN_AUS)

	cpi temp6,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp6,(ZEICHEN_AUS)

	cpi temp5,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp5,(ZEICHEN_AUS)

	cpi temp4,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp4,(ZEICHEN_AUS)

	cpi temp3,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp3,(ZEICHEN_AUS)

	cpi temp2,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp2,(ZEICHEN_AUS)

	cpi temp1,(ZAHL_0)
	brne NULL_FERTIG
	ldi temp1,(ZAHL_0)

NULL_FERTIG:

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; INP: temp1																
; OUT: temp1+2 (z.B."FF") 													
FUNKTION_HEX:
	; SICHERUNGSKOPIE						
	push temp
	; 1-er STELLE		
	mov temp2,temp1
	mov temp,temp1	

	rcall FUNKTION_HEX_UMWANDLUNG
	mov temp1,temp
	; 10-er STELLE		
	mov temp,temp2	
	; NIBBLES tausch	
	swap temp
	rcall FUNKTION_HEX_UMWANDLUNG
	mov temp2,temp
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp
	ret
;-------------------------------------------------------------------------------
FUNKTION_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,0
	breq FUNKTION_HEX_0
	cpi temp,1
	breq FUNKTION_HEX_1
	cpi temp,2
	breq FUNKTION_HEX_2
	cpi temp,3
	breq FUNKTION_HEX_3
	cpi temp,4
	breq FUNKTION_HEX_4
	cpi temp,5
	breq FUNKTION_HEX_5
	cpi temp,6
	breq FUNKTION_HEX_6
	cpi temp,7
	breq FUNKTION_HEX_7
	cpi temp,8
	breq FUNKTION_HEX_8
	cpi temp,9
	breq FUNKTION_HEX_9
	cpi temp,10
	breq FUNKTION_HEX_A
	cpi temp,11
	breq FUNKTION_HEX_B
	cpi temp,12
	breq FUNKTION_HEX_C
	cpi temp,13
	breq FUNKTION_HEX_D
	cpi temp,14
	breq FUNKTION_HEX_E
	cpi temp,15
	breq FUNKTION_HEX_F

FUNKTION_HEX_0:
	ldi temp,(ZAHL_0)
	ret
FUNKTION_HEX_1:
	ldi temp,(ZAHL_1)
	ret
FUNKTION_HEX_2:
	ldi temp,(ZAHL_2)
	ret
FUNKTION_HEX_3:
	ldi temp,(ZAHL_3)
	ret
FUNKTION_HEX_4:
	ldi temp,(ZAHL_4)
	ret
FUNKTION_HEX_5:
	ldi temp,(ZAHL_5)
	ret
FUNKTION_HEX_6:
	ldi temp,(ZAHL_6)
	ret
FUNKTION_HEX_7:
	ldi temp,(ZAHL_7)
	ret
FUNKTION_HEX_8:
	ldi temp,(ZAHL_8)
	ret
FUNKTION_HEX_9:
	ldi temp,(ZAHL_9)
	ret
FUNKTION_HEX_A:
	ldi temp,(ZEICHEN_A)
	ret
FUNKTION_HEX_B:
	ldi temp,(ZEICHEN_B)
	ret
FUNKTION_HEX_C:
	ldi temp,(ZEICHEN_C)
	ret
FUNKTION_HEX_D:
	ldi temp,(ZEICHEN_D)
	ret
FUNKTION_HEX_E:
	ldi temp,(ZEICHEN_E)
	ret
FUNKTION_HEX_F:
	ldi temp,(ZEICHEN_F)
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
