; ##############################################################################
; ##############################################################################
; ##############################################################################
KTY_INITIALISIERUNG:
	; REFERENZ-SPANNUNG			
	sbi (REF_DDR),(REF_PIN_NR)	; auf AUSGANG	
	cbi (REF_PORT),(REF_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
KTY_MESSUNG:
	; Referenz an				
	sbi (REF_PORT),(REF_PIN_NR)					; HIGH		
	; PUNKT on					
	LDS temp,(adr_LED_BYTE_0)
	ori temp, 0b10000000	
	STS(adr_LED_BYTE_0),temp
	; PAUSE						
	rcall wait_1ms
	; Messen							
	rcall MESSEN_0
	cbi (REF_PORT),(REF_PIN_NR)					; LOW		
	; PUNKT off							
	LDS temp,(adr_LED_BYTE_0)
	andi temp, 0b01111111
	STS(adr_LED_BYTE_0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
KTY_BERECHNUNG_MIT_FORMEL:
	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)
	; OFFSET-addieren					
	LDS temp3,(adr_KTY_OFFSET_L)	
	LDS temp4,(adr_KTY_OFFSET_H)	
	add temp1,temp3
	adc temp2,temp4

	; TESTZAHL							
;	ldi temp1,LOW (350); -50 C
;	ldi temp2,HIGH(350)
;	ldi temp1,LOW (646); +100 C
;	ldi temp2,HIGH(646)

	; MINUS 462							
	subi temp1,LOW (462)
	sbci temp2,HIGH(462) 
	; mal 5 (4xaddieren)				
	mov R0,temp1
	mov R1,temp2
	add temp1,R0
	adc temp2,R1
	add temp1,R0
	adc temp2,R1
	add temp1,R0
	adc temp2,R1
	add temp1,R0
	adc temp2,R1
	; SPEICHERN							
	STS(adr_TEMPERATUR_KTY_L),temp1
	STS(adr_TEMPERATUR_KTY_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
KTY_BERECHNUNG:
	; ADC-WERT laden (339...707)
	LDS temp1,(adr_ADC_0_L)
	LDS temp2,(adr_ADC_0_H)
	; OFFSET-addieren			
	LDS temp3,(adr_KTY_OFFSET_L)	
	LDS temp4,(adr_KTY_OFFSET_H)	
	add temp1,temp3
	adc temp2,temp4
	; ERROR berlauf			
	cpi temp2,HIGH(707)
	brlo KTY_BERECHNUNG_ww
	breq KTY_BERECHNUNG_w
	rjmp KTY_BERECHNUNG_ERROR
KTY_BERECHNUNG_w:
	cpi temp1,LOW (707)
	brlo KTY_BERECHNUNG_ww
	breq KTY_BERECHNUNG_ww
	rjmp KTY_BERECHNUNG_ERROR
KTY_BERECHNUNG_ww:
	; MINUS START-Wert			
	subi temp1,LOW (339)
	sbci temp2,HIGH(339)
	; ERROR (negativ) ?			
	tst temp2
	brmi KTY_BERECHNUNG_ERROR
;-------------------------------------------------------------------------------
	; Z auf TABELLE				
	ldi ZL,LOW (TABELLE_KTY81_122*2)
	ldi ZH,HIGH(TABELLE_KTY81_122*2)	
	; 2xaddieren				
	add ZL,temp1
	adc ZH,temp2
	add ZL,temp1
	adc ZH,temp2
	; aus Tabelle laden			
	LPM temp1, Z+   			; LOW  aus Tabelle laden und Zeiger um 1 erhhen
	LPM temp2, Z    			; HIGH aus Tabelle laden						
	; SPEICHERN							
	STS(adr_TEMPERATUR_KTY_L),temp1
	STS(adr_TEMPERATUR_KTY_H),temp2
	ret
;-------------------------------------------------------------------------------
KTY_BERECHNUNG_ERROR:
	ldi temp1,LOW (8888)
	ldi temp2,HIGH(8888)
	STS(adr_TEMPERATUR_KTY_L),temp1
	STS(adr_TEMPERATUR_KTY_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; KTY81-122																		
; Zahlenrechner																	
; 16.10.2015;22:54:38															
; Temperatur in Abhngigkeit ADC												
; -55...150C																	
; 																				
; R1:     1000																	
; Uges:   5																		
; Uref:   5																		
; ADC-MIN: 339 																	
; ADC-MAX: 707 																	
; 																				
TABELLE_KTY81_122:
.dw -550 ,-546 ,-542 ,-538 ,-533 ,-529 ,-524 ,-520 ,-515 ,-511 
.dw -506 ,-502 ,-498 ,-493 ,-489 ,-485 ,-480 ,-476 ,-472 ,-467 
.dw -463 ,-459 ,-454 ,-450 ,-445 ,-441 ,-437 ,-432 ,-428 ,-423 
.dw -419 ,-414 ,-410 ,-405 ,-401 ,-396 ,-392 ,-388 ,-384 ,-379 
.dw -375 ,-371 ,-366 ,-362 ,-358 ,-353 ,-349 ,-344 ,-340 ,-335 
.dw -331 ,-327 ,-322 ,-318 ,-313 ,-309 ,-304 ,-300 ,-295 ,-291 
.dw -287 ,-282 ,-278 ,-273 ,-269 ,-264 ,-260 ,-256 ,-251 ,-247 
.dw -242 ,-238 ,-233 ,-228 ,-224 ,-219 ,-215 ,-210 ,-206 ,-201 
.dw -197 ,-192 ,-188 ,-184 ,-179 ,-175 ,-170 ,-166 ,-162 ,-157 
.dw -153 ,-148 ,-144 ,-139 ,-135 ,-130 ,-126 ,-121 ,-117 ,-112 
.dw -108 ,-103 ,-98 ,-94 ,-90 ,-85 ,-81 ,-76 ,-72 ,-67 
.dw -62 ,-58 ,-53 ,-49 ,-44 ,-39 ,-35 ,-30 ,-26 ,-21 
.dw -16 ,-11 ,-7 ,-2 , 3 , 7 , 12 , 16 , 21 , 26 
.dw  30 , 35 , 39 , 44 , 49 , 53 , 58 , 63 , 68 , 72 
.dw  77 , 82 , 87 , 92 , 96 , 101 , 106 , 110 , 115 , 120 
.dw  125 , 129 , 134 , 139 , 143 , 148 , 153 , 158 , 163 , 168 
.dw  172 , 177 , 182 , 187 , 192 , 197 , 202 , 207 , 212 , 217 
.dw  222 , 227 , 232 , 237 , 242 , 247 , 252 , 257 , 262 , 267 
.dw  272 , 277 , 282 , 287 , 292 , 297 , 302 , 307 , 312 , 317 
.dw  322 , 327 , 332 , 337 , 342 , 347 , 352 , 357 , 362 , 367 
.dw  373 , 378 , 383 , 388 , 393 , 399 , 404 , 409 , 414 , 419 
.dw  425 , 430 , 435 , 440 , 446 , 451 , 456 , 462 , 467 , 472 
.dw  478 , 483 , 489 , 494 , 500 , 505 , 510 , 516 , 521 , 527 
.dw  532 , 537 , 543 , 548 , 554 , 559 , 565 , 571 , 576 , 582 
.dw  588 , 593 , 599 , 605 , 610 , 616 , 621 , 627 , 633 , 638 
.dw  644 , 650 , 656 , 662 , 667 , 673 , 679 , 685 , 691 , 697 
.dw  703 , 709 , 714 , 720 , 726 , 732 , 738 , 744 , 750 , 756 
.dw  762 , 768 , 774 , 780 , 786 , 792 , 798 , 804 , 810 , 816 
.dw  822 , 829 , 835 , 841 , 847 , 853 , 860 , 866 , 872 , 879 
.dw  885 , 892 , 898 , 904 , 911 , 917 , 923 , 930 , 936 , 943 
.dw  949 , 956 , 962 , 969 , 976 , 982 , 989 , 996 , 1002 , 1009 
.dw  1016 , 1022 , 1029 , 1036 , 1042 , 1049 , 1056 , 1063 , 1070 , 1077 
.dw  1084 , 1091 , 1098 , 1105 , 1112 , 1119 , 1126 , 1133 , 1140 , 1148 
.dw  1155 , 1162 , 1170 , 1177 , 1185 , 1192 , 1200 , 1207 , 1215 , 1223 
.dw  1231 , 1238 , 1246 , 1254 , 1262 , 1270 , 1278 , 1286 , 1295 , 1303 
.dw  1312 , 1321 , 1330 , 1339 , 1348 , 1357 , 1367 , 1376 , 1385 , 1395 
.dw  1405 , 1416 , 1427 , 1439 , 1450 , 1462 , 1473 , 1485 , 1496 , 1500 
.dw  1500 , 1500 
